using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;

namespace cestini
{
    class Program
    {
        public String Solve(int N, int M, int Q, String S, char[] type, int[] A, int[] B)
        {
            // Aggiungi codice se vuoi

            List<char> risposta = new List<char>();

            for (int i = 0; i < Q; i++) {
                if (type[i] == 's') {
                    // Aggiungi codice...

                } else if (type[i] == 'c') {
                    // Aggiungi altro codice...

                    risposta.Add('A');
                }
            }

            return String.Join("", risposta);
        }

        public void Run()
        {
            // Se preferisci leggere e scrivere da file
            // ti basta modificare la seguente variabile
            bool input_from_file = false;

            if (input_from_file) {
                streamReader = new StreamReader("input.txt");
                streamWriter = new StreamWriter("output.txt");
            } else {
                streamReader = new StreamReader(Console.OpenStandardInput());
                streamWriter = new StreamWriter(Console.OpenStandardOutput());
            }

            iterator = GetEnumerator(streamReader);

            int T = NextInt();

            for (int t = 1; t <= T; t++) {
                int N = NextInt();
                int M = NextInt();
                int Q = NextInt();

                String S = NextToken();

                char[] type = new char[Q];
                int[] A = new int[Q];
                int[] B = new int[Q];

                for (int i = 0; i < Q; i++) {
                    type[i] = NextToken()[0];
                    A[i] = NextInt();
                    B[i] = NextInt();
                }

                String risposta = Solve(N, M, Q, S, type, A, B);
                streamWriter.Write($"Case #{t}: {risposta}\n");
                streamWriter.Flush();
            }

            streamReader.Close();
            streamWriter.Close();
        }

        public IEnumerator<String> GetEnumerator(StreamReader sr)
        {
            String line;
            while ((line = sr.ReadLine()) != null) {
                String[] tokens = line.Split(' ').Where(t => t.Length > 0).ToArray();
                foreach (String t in tokens) {
                    yield return t;
                }
            }
        }

        public String NextToken()
        {
            iterator.MoveNext();
            return iterator.Current;
        }

        public int NextInt()
        {
            return Convert.ToInt32(NextToken());
        }

        static void Main(String[] args)
        {
            var program = new Program();
            program.Run();
        }

        private StreamReader streamReader;
        private StreamWriter streamWriter;
        private IEnumerator<String> iterator;
    }
}
